import { HttpClient } from "@angular/common/http";
import { Injectable } from "@angular/core";
import { throwError } from "rxjs";
import { catchError } from "rxjs/operators";
import { AppSettings } from "src/app/model/config/app-settings";

@Injectable({
  providedIn: "root",
})
export class SettingsService {
  settings!: AppSettings;

  constructor(private http: HttpClient) {}

  loadSettings(): Promise<void> {
    return new Promise((resolve, reject) => {
      this.http
        .get<AppSettings>("/assets/config.json")
        .pipe(
          catchError((error) => {
            reject(error);
            return throwError(() => error);
          }),
        )
        .subscribe((settings) => {
          this.settings = settings;
          resolve();
        });
    });
  }
}
